#include <stdio.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <unistd.h>
#include <string.h>
#include <stdlib.h>

int main (int argc, char ** argv) 
{
  int s, N;
  struct sockaddr_in sin;

  if (argc != 2) {
    fprintf (stderr, "usage: %s numofint\n", argv[0]);
    return 1;
  }

  N = atoi(argv[1]);

  if (N <= 0) {
    fprintf (stderr, "usage: %s numofint\n", argv[0]);
    return 1;
  }

  if ( (s = socket (PF_INET, SOCK_STREAM, 0)) < 0) {
    fprintf (stderr, "Error \n");
    return 1;
  }

  bzero ((void *) &sin, sizeof (sin));

  sin.sin_family = AF_INET;
  inet_aton ("127.0.0.1", &(sin.sin_addr));
  sin.sin_port = htons ( (u_short) 1025);

  if ( (connect (s, (struct sockaddr *)&sin, sizeof (sin) )) == 0) {
    int nr, i;
    int * buf;

    if ((buf = (int *) malloc (sizeof(int) * N)) == NULL) {
      fprintf (stderr, "Memory allocation error\n");
      close (s);
      return 1;
    }

    fprintf (stdout, "connect to %s [%d]\n", inet_ntoa (sin.sin_addr), 
        ntohs (sin.sin_port) );
    nr = write (s, &N, sizeof(int));
    if (nr != sizeof(int)) {
      fprintf (stderr, "error write \n");
      close (s);
      return 1;
    }

    for (i=0; i<N; i++)
      buf[i] = i;
      //buf[i] = htonl(i);

    nr = write (s, buf, N*sizeof(int));

    if (nr != (int) (sizeof(int)*N)) 
      fprintf (stderr, "error write \n");

    free (buf);
  }
  else
    fprintf (stderr, "no connection\n");

  close (s);

  return 0;
}
