#include <stdio.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <unistd.h>
#include <string.h>
#include <stdlib.h>

int main () 
{
  int s;
  struct sockaddr_in sin;

  if ( (s = socket (PF_INET, SOCK_STREAM, 0)) < 0) {
    fprintf (stderr, "Error \n");
    return 1;
  }

  bzero ((void *) &sin, sizeof (sin));

  sin.sin_family = AF_INET;
  inet_aton ("0.0.0.0", &(sin.sin_addr));
  sin.sin_port = htons ( (u_short) 1025);

  if(bind(s, (struct sockaddr *) &sin, sizeof (sin)) != 0) {
    fprintf (stderr, "Error bind\n");
    return 1;
  }

  if (listen (s, 1) != 0) {
    fprintf (stderr, "Error listen\n");
    return 1;
  }

  while (1) {
    int ssock;
    socklen_t alen;
    struct sockaddr_in fin;

    bzero ((void *) &fin, sizeof (fin));
    alen = sizeof (fin);

    if ( (ssock = accept (s, (struct sockaddr *)&fin, &alen )) > 0) {
      int N, nr;

      fprintf (stdout, "accept from: %s [%d]\n", inet_ntoa (fin.sin_addr), ntohs (fin.sin_port) );

      nr = read (ssock, &N, sizeof(int));
      if (nr != sizeof(int))  {
        fprintf (stderr, "Error read\n");
        close (ssock);
      }
      else {
        int * buf;
        int i;

        if ((buf = (int *) malloc (sizeof(int) * N)) == NULL) {
          fprintf (stderr, "Memory allocation error\n");
          close (ssock);
          close (s);
          return 1;
        }

        nr = read (ssock, buf, sizeof(int)*N);

        if (nr == (int) (sizeof(int)*N)) {
          for (i=0; i<N; i++) 
            fprintf (stdout, "int[%3d]= %d \n", i+1, buf[i]);
        }
        else 
          fprintf (stderr, "error read \n");

        close (ssock);
        free (buf);
      }
    }
    else {
      fprintf (stderr, "Error accept\n");
      close (s);
      return 1;
    }
  }

  close (s);

  return 0;
}
