#include <stdio.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#include "util.h"

int main () 
{
  int s;
  struct sockaddr_in sin;

  if ( (s = socket (PF_INET, SOCK_STREAM, 0)) < 0) {
    fprintf (stderr, "Error \n");
    return 1;
  }

  bzero ((void *) &sin, sizeof (sin));

  sin.sin_family = AF_INET;
  inet_aton ("0.0.0.0", &(sin.sin_addr));
  sin.sin_port = htons ( (u_short) 1025);

  if(bind(s, (struct sockaddr *) &sin, sizeof (sin)) != 0) {
    fprintf (stderr, "Error bind\n");
    return 1;
  }

  if (listen (s, 1) != 0) {
    fprintf (stderr, "Error listen\n");
    return 1;
  }

  while (1) {
    int ssock;
    socklen_t alen;
    struct sockaddr_in fin;

    bzero ((void *) &fin, sizeof (fin));
    alen = sizeof (fin);

    if ( (ssock = accept (s, (struct sockaddr *)&fin, &alen )) > 0) {
      int N, nr;

      fprintf (stdout, "accept from: %s [%d]\n", inet_ntoa (fin.sin_addr), ntohs (fin.sin_port) );

      nr = read (ssock, &N, sizeof(int));
      if (nr != sizeof(int))  {
        fprintf (stderr, "Error read\n");
        close (ssock);
      }
      else {
        double t1, Mb;
        int * buf;
        int i;

        if ((buf = (int *) malloc (sizeof(int) * N)) == NULL) {
          fprintf (stderr, "Memory allocation error\n");
          close (ssock);
          close (s);
          return 1;
        }

        t1 = tempo ();
        nr = leggisock (ssock, (void *) buf, sizeof(int)*N);
        t1 = tempo () - t1; 
        if (nr != (int) (N*sizeof(int))) {
          fprintf (stderr, "error read \n");
        }
        else {
          for (i=0; i<N; i++) 
            if (buf[i] != i)
              fprintf (stdout, "error: int[%3d] == %d \n", i+1, buf[i]);
        }
        Mb = (double) (sizeof(int) * N) / (1024.0e0 * 1024.0e0);
        fprintf (stdout, "done %6.2f Mb in %10.2f s [%10.2f Mb/s] \n", Mb, t1, (Mb / t1));

        close (ssock);
        free (buf);
      }
    }
    else {
      fprintf (stderr, "Error accept\n");
      close (s);
      return 1;
    }
  }

  close (s);

  return 0;
}
