#include <unistd.h>
#include <errno.h>

int leggisock(int fd, void *buf, size_t conta)
/*
* legge "conta" byte da un descrittore
* da usare al posto di read quando fd e' un socket di tipo stream
*/
{
    int mancano, letti;
    mancano = conta;

    while (mancano>0) {
        letti = read(fd, buf, mancano);
        if ( (letti<0) && (errno!=EINTR) )
            return(letti);         // errore
        else
            if (letti==0)
                break;            // EOF
        mancano = mancano - letti;
        buf = buf + letti;
    }            

    return(conta - mancano);
}    

int scrivisock(int fd, void *buf, size_t conta)
/*
* scrive "conta" byte su un descrittore
* da usare al posto di write quando fd e' un socket di tipo stream
*/
{
    int mancano, scritti;
    mancano = conta;

    while (mancano>0) {
        scritti = write(fd, buf, mancano);
        if ( (scritti<=0) && (errno!=EINTR) )
            return(scritti);         // errore
        mancano = mancano - scritti;
        buf = buf + scritti;
    }            

    return(conta - mancano);
}

#include <sys/time.h>
#include <unistd.h>

double tempo ()
{
  double secs;
  double zero=9.29e8;
  struct timeval now;
  struct timezone time_z;

  gettimeofday ( &now, &time_z );
  secs = ((double) now.tv_sec) - zero;
  secs += ((double) now.tv_usec*1.0e-6 );

  return secs;
}
